function parameter = panel_fe(y, x, T)
%PANEL_ESTIMATE estimate the parameter of panel data model under the
%setting of fixed effect

[a, ~] = size(x);
N = a/T;

j_bar = ones(T)./T;
j_all = kron(eye(N),j_bar); 
q_all = eye(N*T) - j_all;

x_fe = q_all * x;
y_fe = q_all * y;

parameter = (x_fe' * x_fe) \ (x_fe' * y_fe);
end

